summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: 7905ba6)
raw | patch | inline | side by side (parent: 7905ba6)
author | Junio C Hamano <junkio@cox.net> | |
Wed, 17 Jan 2007 04:46:39 +0000 (20:46 -0800) | ||
committer | Junio C Hamano <junkio@cox.net> | |
Wed, 17 Jan 2007 05:32:06 +0000 (21:32 -0800) |
This allows "git checkout -m <other-branch>" to notice renames and
carry local changes in the working tree forward.
Signed-off-by: Junio C Hamano <junkio@cox.net>
carry local changes in the working tree forward.
Signed-off-by: Junio C Hamano <junkio@cox.net>
git-checkout.sh | patch | blob | history | |
t/t7201-co.sh | patch | blob | history |
diff --git a/git-checkout.sh b/git-checkout.sh
index 66e40b90ebfa8e65e9c42731203f10dde0424b8c..e02d4d87f622bf73ad04c356ff15ac6e0a626aa6 100755 (executable)
--- a/git-checkout.sh
+++ b/git-checkout.sh
git diff-files --name-only | git update-index --remove --stdin &&
work=`git write-tree` &&
git read-tree --reset -u $new &&
- git read-tree -m -u --aggressive --exclude-per-directory=.gitignore $old $new $work ||
- exit
+ eval GITHEAD_$new=${new_name:-${branch:-$new}} GITHEAD_$work=local &&
+ export GITHEAD_$new GITHEAD_$work &&
+ git merge-recursive $old -- $new $work || exit
if result=`git write-tree 2>/dev/null`
then
diff --git a/t/t7201-co.sh b/t/t7201-co.sh
index 085d4a096b90e076afef70a7e8b7746f58a49060..315fa3564c744e2601fc1469516337b436d056cb 100755 (executable)
--- a/t/t7201-co.sh
+++ b/t/t7201-co.sh
done
}
+
test_expect_success setup '
- fill 1 2 3 4 5 >one &&
+ fill 1 2 3 4 5 6 7 8 >one &&
fill a b c d e >two &&
git add one two &&
git commit -m "Initial A one, A two" &&
- git checkout -b side &&
- fill 1 2 3 >one &&
+ git checkout -b renamer &&
+ rm -f one &&
+ fill 1 3 4 5 6 7 8 >uno &&
+ git add uno &&
+ fill a b c d e f >two &&
+ git commit -a -m "Renamer R one->uno, M two" &&
+
+ git checkout -b side master &&
+ fill 1 2 3 4 5 6 7 >one &&
fill A B C D E >three &&
rm -f two &&
git update-index --add --remove one two three &&
test_expect_success "checkout with dirty tree without -m" '
- fill 0 1 2 3 4 5 >one &&
+ fill 0 1 2 3 4 5 6 7 8 >one &&
if git checkout side
then
echo Not happy
git checkout -f master &&
git clean &&
- fill 0 1 2 3 4 5 >one &&
+ fill 0 1 2 3 4 5 6 7 8 >one &&
git checkout -m side &&
- fill " master" "* side" >expect.branch &&
- git branch >current.branch &&
- diff expect.branch current.branch &&
+ test "$(git symbolic-ref HEAD)" = "refs/heads/side" &&
fill "M one" "A three" "D two" >expect.master &&
git diff --name-status master >current.master &&
diff expect.index current.index
'
+test_expect_success "checkout -m with dirty tree, renamed" '
+
+ git checkout -f master && git clean &&
+
+ fill 1 2 3 4 5 7 8 >one &&
+ if git checkout renamer
+ then
+ echo Not happy
+ false
+ else
+ echo "happy - failed correctly"
+ fi &&
+
+ git checkout -m renamer &&
+ fill 1 3 4 5 7 8 >expect &&
+ diff expect uno &&
+ ! test -f one
+'
+
test_done